#!/bin/bash
#
# include:
# logging.inc
# 
# ---------------------------------


logging()
{

   local number=$1
   local function=$2
   local messages="ERROR"
   local message_date=""
   local message_note=""
   local dummy="                                        "
   
   if [ $number -ge 900 ]
   then
      messages="INFOS"
   fi
   
   case "$1" in
	
	      1)      
	        message_note="Rechner-IP's sind nicht gleich!"
	        ;;

	      2)
	        message_note="Rechner existiert nicht!"
	        ;;
   
          900)
             message_note="Programm startet!"$CRLF
	        ;;
	        
	      901)
             message_note="Programmteil: Projekt-Daten startet!"$CRLF
	        ;; 
	      902)
             message_note="Programmteil: Projekt-Daten beendet!"$CRLF
	        ;; 	        
	      999)
             message_note="Progranm beendet!"$CRLF
	        ;;
	         
          *)
            message_note="Unbekannter Fehler!"
            ;;
          
    esac
   
   
      
   message_date=$(date "+%d.%m.%Y | %H:%M:%S : ->")
   message_date=" $message_date $messages "[" $number "]""
    
   printf "$message_date <<$function>> $CRLF $dummy $message_note" >> $log_filename
   
   

}
