#!/bin/bash
#

pos_x_y()
#--------
{
  local z=$1
  local s=$2

  echo -en "\033["$z";"$s"H"
}


check_key()
#----------
{
 local key=$KEY_BUFFER
 KEY_POS_X=$1
 KEY_POS_Y=$2
 KEY_COUNTER=$3



 case "$key" in

 $'\x7f')  # Backspace
           #exit
           return 8
           ;;
 $'\x1b\x5b\x32\x7e')  # Insert
					   #echo Insert Key
					   return 48
                       ;;
 $'\x1b\x5b\x33\x7e')  # Del
					   #echo Insert Key
					   return 49
                       ;;

  $'\x1b\x5b\x41')  # Up_arrow / oben
					#echo Up arrow
					return 41
					;;
  $'\x1b\x5b\x42')  # Down_arrow / unten
					#echo Down arrow
					return 13
					;;
  $'\x1b\x5b\x43')  # Right_arrow
					#echo Right arrow
					return 43
					;;
  $'\x1b\x5b\x44')  # Left_arrow
					#echo Left arrow
					return 44
					;;

  $'\x0a')  # Enter
		    #echo Enter Key
		    return 13
            ;;

  $'\x20')  # Space
		    #echo "Space Key"
			return 20
            ;;
  $'\x09')  # Tab
            #echo TAB
            return 99
            ;;
  $'\x1b')  # Escape
            return 27
             ;;


 esac
 return 0

}




get_key()
#---------
{
   local return_value

   KEY_BUFFER=""
   unset K1 K2 K3
   # -sn1
   read -s -N1 -p ''
   K1="$REPLY"
   read -s -N2 -t 0.003
   K2="$REPLY"
   read -s -N1 -t 0.003
   K3="$REPLY"
   KEY_BUFFER="$K1$K2$K3"

   check_key
   return_value=$?
   case "$return_value" in
		 0) # Normal Keys
            return 0
            ;;
         8) # Backspace
            return 8
            break
            ;;
        27) #ESC
            return 27
            break
            ;;
	    13) # Return
	        return 13
            break
            ;;
        20) # Space
            KEY_BUFFER=$LEER_CHAR
            return 0
            ;;
        41) # Up_arrow / oben
            return 41
            break
            ;;
        43) # Righ
            #KEY_BUFFER=$LEER_CHAR
            return 43
            #return 0
            break
            ;;
        44) # Left
            return 44
            break
            ;;
        48) # Insert
            #KEY_BUFFER=$LEER_CHAR
            return 48
            break
            ;;
        49) # Delet
            #KEY_BUFFER=$LEER_CHAR
            return 49
            break
            ;;
		99) # Muellkorb Keys
            return 99
            break
            ;;
   esac

}


write_to_cache_field()
#---------------------
{
  #printf "|"$1"|"
  CACHE_FIELD[$1]=$1":"$KEY_BUFFERS
  #printf ${CACHE_FIELD[$1]}
}

read_from_cache_buffer()
{
  local buffer=$1
  local tmp

  tmp=${CACHE_FIELD[${buffer:7:1}]}
  tmp=${tmp:2:(${#tmp})}
  echo $tmp
}

row_clear()
{
  local row_length
  local i
  local z  #zeile
  local s  #spalte
  local co_z # co-faktor
  local co_s # co-faktor


  row_length=$1
  z=$2
  s=$3
  co_z=0
  co_s=0
  printf "\e[%d;%dH" $((z+co_z)) $((s+co_s))
  i=1
  # oder einfach nur $((row_length)): (($i;i<=$((row_length+1));i++))
  for (($i;i<$((row_length+1));i++))
  do
    printf " "
  done

}

build_row()
#------------
{
  local row_length
  local i
  local z  #zeile
  local s  #spalte
  local co_z # co-faktor für Bildschirm printf
  local co_s # co-faktor für Bildschirm printf
  local co_pos_x # co-faktor für Cursor_POS
  local co_pos_y # co-faktor für Cursor_POS
  local line

  line="${1}"
  #linie=$1
  row_length=$2
  z=$3
  s=$4
  co_z=$5
  co_s=$6
  co_pos_z=$7
  co_pos_s=$8

  printf "\e[%d;%dH" $((z+co_z)) $((s+co_s))
  printf $line
  pos_x_y $((z+co_pos_z)) $((s+co_pos_s))
}

set_counter_and_spalten()
{
  local _i=$1
  local _s=$2
  local dec
  local inc
  local w=0

  local x=$3

  if [ "$x" = "+" ]
  then
       _i=$(( _i+1))
       #_s=$(( _s+1))
       w=1
  fi
  if [ "$x" = "-" ]
  then
       _i=$(( _i-1))
       #_s=$(( _s-1))
       w=1
  fi
  if [ "$x" = "++" ]
  then
       #_i=$(( _i+1))
       _s=$(( _s+1))
       w=2
  fi
  if [ "$x" = "--" ]
  then
       #_i=$(( _i-1))
       _s=$(( _s-1))
       w=2
  fi
  if (( $w == 1 ))
  then
    echo $_i
  fi
  if (( $w == 2 ))
  then
    echo $_s
  fi



}


goto_xy_input()
#-------------
{
 local zeile            #ok
 local spalte  			#ok
 local input_length     #ok
 local input_field		#ok -> FIELD-xx Name
 local anz_chars        #ok
 local input_buffer
 local return_value
 local return_field
 local i
 local co_1=1
 local ii
 local jump=$WAHR
 local memo_s
 local memo_s
 local tmp
 local string_tmp
 local del_pos
 local ins_pos
 local mask_leave
 

 zeile=$1
 memo_z=$zeile
 spalte=$2
 memo_s=$spalte
 input_length=$3
 input_field=$4
 mask_leave=$5
 anz_chars=$input_length
 EXIT_FIELD=$FALSCH
 tmp="$(read_from_cache_buffer $input_field)"

 while [ $EXIT_FIELD = $FALSCH ]
 #- Schleife für FIELD-xx -#
 do
     ii=1
     for (($ii;ii<$((anz_chars+1));ii++))
     do
        printf " "
     done
      
          
     input_buffer=$tmp
     #if (( ${#tmp} > 0 ))
     #then
     #    echo "***"
     #else
     #    echo "    "
     #fi         
         
     # Einlesen von schon angesprungenem Feld!
     # Tip : read_from_cache_buffer
     ii=1
     for  (( $ii;ii<=${#tmp};ii++ ))
     do
	   input_buffer[ii]=${tmp:$((ii-1)):1}
	 done
     i=1
     for (( $i;i<=${anz_chars};i++ ))
     do

       pos_x_y $zeile $spalte
	   get_key
	   return_value=$?
	   # Eingabe Regulärer Tasten -> ok
	   if (( $return_value == 0 ))
	   then
	     
	       input_buffer[i]=$KEY_BUFFER
	
	  
	       # Array Concatenon!
	       #input_buffer+=( "${input_buffer[0]}" )
	       
	       build_row "${input_buffer[i]}" $((${#input_buffer[i]})) $memo_z $spalte 0 0 0 0
	       spalte=$((spalte+1))
	       KEY_BUFFER=""
	       if (( ${#input_buffer[@]} >= $anz_chars ))
	       then
	            jump=$FALSCH
	       else
	            jump=$WAHR
	       fi
		   pos_x_y $zeile $spalte
	   else
	      # ---------------------------
	      if (( $return_value == 8  ))
	      # Backspace
	      # ---------------------------
	      then
		      KEY_BUFFER=""
	          jump=$FALSCH    #!ganz wichtig
	          i=$((i-2))
	          spalte=$((spalte-1))
              string_tmp="" # wichtig!
	          #------------------
	          # array_to_string
			  #------------------
			  ii=1
			  for (($ii;ii<=$anz_chars;ii++))
			  do
				 string_tmp=$string_tmp${input_buffer[ii]}
			  done

	          # Bestimmung des Loeschobjektes
			  del_pos=$i
			  if (( $del_pos >= 0 ))
			  then
				  # loeschen links des Cursors
				  #string_tmp=${string_tmp:0:$del_pos}${string_tmp:${#string_tmp}}
				  string_tmp=${string_tmp:0:$((del_pos))}${string_tmp:$((del_pos+1)):$anz_chars}
			  fi

	          row_clear $anz_chars $memo_z $memo_s
			  build_row $string_tmp ${#string_tmp} $memo_z $memo_s
			  # string_to_array
			  #------------------
			  ii=1
			  unset input_buffer
			  #input_buffer=$string_tmp
			  for  (( $ii;ii<=${#string_tmp};ii++ ))
			  do
			  	 input_buffer[ii]=${string_tmp:$((ii-1)):1}
			  done

	          if (( i<=0 ))
	          then
	               i=0
	               spalte=$memo_s
	          fi

	          string_tmp=""
	      fi
	      
	      # ---------------------------
	      if (( $return_value == 13  ))
	      # return / down
	      # ---------------------------
	      then
	          KEY_BUFFER=""
	          jump=$FALSCH    #!ganz wichtig
	          break
	      fi
	      
	      # ---------------------------
          if (( $return_value == 27  ))
	      # ESC
	      # ---------------------------
	      then
	          KEY_BUFFER=""
	          input_buffer=""
	          string_tmp=""
	          tmp=""
	          i=1
	          jump=$FALSCH    #!ganz wichtig
	          KEY_BUFFERS=""
              row_clear $anz_chars $memo_z $memo_s
              unset input_buffer
              spalte=$memo_s
	          break
	      fi

		  # ---------------------------
	      if (( $return_value == 41  ))
	      # up
	      # ---------------------------
	      then
	          KEY_BUFFER=""
	          STEUERUNG=$STEUERUNG_OBEN
	          jump=$FALSCH    #!ganz wichtig
	          break
	      fi
		
          # ---------------------------
	      if (( $return_value == 43  ))
	      # rechts
	      # ---------------------------
	      then
	          KEY_BUFFER=""
			  jump=$WAHR    #!ganz wichtig
              if (( $i >= $anz_chars ))
			  then
			      i=$((anz_chars-1))
			      spalte=$((spalte-1))
			  fi
	          spalte=$((spalte+1))
	      fi

          # ---------------------------
	      if (($return_value == 44  ))
	      # links
	      # ---------------------------
	      then
	          KEY_BUFFER=""
			  jump=$WAHR    #!ganz wichtig
			  i=$((i-2))
			  spalte=$((spalte-1))

			  if (( i<=0 ))
	          then
	               i=0
	               spalte=$memo_s
	          fi
	      fi

          # ---------------------------
	      if (( $return_value == 48 ))
	      # insert
	      # ---------------------------
	      then
	          KEY_BUFFER=$LEER_CHAR
	          string_tmp=''
			  jump=$FALSCH    #!ganz wichtig

              #------------------
	          # array_to_string
			  #------------------
			  ii=1
			  for (($ii;ii<=$anz_chars;ii++))
			  do
				 string_tmp=$string_tmp${input_buffer[ii]}
			  done
              #----------------------------------------------------------------------
              # position wo eingefügt wird, string nach links, fuegt leerzeichen ein
              #----------------------------------------------------------------------
			  ins_pos=$i
			  string_tmp=${string_tmp:0:((ins_pos-1))}$KEY_BUFFER${string_tmp:((ins_pos-1)):$anz_chars}
			  row_clear $anz_chars $memo_z $memo_s
			  build_row $string_tmp ${#string_tmp} $memo_z $memo_s
			  #i=$((ins_pos-1))
			  #------------------
			  # string_to_array
			  #------------------
			  ii=1
			  unset input_buffer
			  #input_buffer=$string_tmp
			  for  (( $ii;ii<=${#string_tmp};ii++ ))
			  do
			  	 input_buffer[ii]=${string_tmp:$((ii-1)):1}
			  done
              #i=$((i+1))
              spalte=$((spalte+1))
	      fi
           
          # ---------------------------
	      if (( $return_value == 49  ))
	      # Del
	      # ---------------------------
	      then
	          jump=$FALSCH    #!ganz wichtig
	          string_tmp=""
	          KEY_BUFFER=""
	          if (( $i > 0 ))
	          then
	              unset input_buffer[i]
	              #------------------
	              # array_to_string
			      #------------------
			      ii=1
				  for (($ii;ii<=$anz_chars;ii++))
				  do
					 string_tmp=$string_tmp${input_buffer[ii]}
				  done
	              i=$((i-1))
	              row_clear $anz_chars $memo_z $memo_s
	              printf "\e[%d;%dH" $memo_z $memo_s
	              build_row $string_tmp ${#string_tmp} $memo_z $memo_s
	              #------------------
				  # string_to_array
				  #------------------
				  ii=1
				  unset input_buffer
				  #input_buffer=$string_tmp
				  for  (( $ii;ii<=${#string_tmp};ii++ ))
				  do
					 input_buffer[ii]=${string_tmp:$((ii-1)):1}
				  done
				  fi
				  string_tmp=""
	      
	      fi 

          # ---------------------------
	      if (( $return_value == 99  ))
	      # TastaturMüll
	      # ---------------------------
	      then
	          KEY_BUFFER=""
	          jump=$WAHR    #!ganz wichtig
	          printf "\e[%d;%dH" 20 15 #$memo_z $memo_s
              printf "i:"$i
	          if (( $i > 0 ))
              then
                i=$((i-1))
                printf "\e[%d;%dH" 21 15 #$memo_z $memo_s
                printf "i:"$i
              fi
	          break
	      fi
	   fi
	   pos_x_y $zeile $spalte

     done

     if (( $jump == $FALSCH )) && (( ${#input_buffer[@]} != 0 ))
     then
         zeile=$memo_z
         spalte=$memo_s
         #KEY_BUFFERS=""
         for (( ii=1;ii<=$anz_chars;ii++ ))
		 # -- array -> string --#
         do
           KEY_BUFFERS=$KEY_BUFFERS${input_buffer[ii]}
         done
         printf "\e[%d;%dH" $zeile $spalte
         if (( ${#KEY_BUFFERS} > 0  ))
         then
            #printf "${KEY_BUFFERS,,}" # nur nach Wunsch!
            printf $KEY_BUFFERS
            if (( ${#mask_leave} > 0 ))
            then
				if [ "${KEY_BUFFERS,,}" == "ja"  ] || [ "${KEY_BUFFERS,,}" == "yes" ]
				then
				   EXIT_FIELD=$WAHR
				   EXIT_MASK=$WAHR
				   break
				else
				   row_clear $anz_chars $memo_z $memo_s    
				fi
            fi
            #echo $KEY_BUFFERS >> test.daten
            echo $input_field":"$KEY_BUFFERS >> $config_daten
            write_to_cache_field ${input_field:7:1}
         fi
     fi
     jump=$FALSCH
     unset input_buffer


 if (( $return_value != 27 ))
 then
    EXIT_FIELD=$WAHR
 fi
 done

}


mask_01_entry()
#--------------
{
  local anz_fields=$1
  #local ok_field=$2
  local field_txt_length
  local field_input_length
  #local input_field=$3
  local z
  local s
  local i
  local tmp


  ACTUAL_FIELD_NUMBER=0
  EXIT_MASK=$FALSCH
  EXIT_FIELD=$FALSCH

  echo -n > $config_daten

  while [ $EXIT_MASK = $FALSCH ]
  #- Schleife für totale Maske -#
  do

    for (( i=1;i<=$anz_fields;i++ ))
    #-- Maske --#
    do

        if (( $STEUERUNG == $STEUERUNG_OBEN ))
        then
             i=$((i-2))
             STEUERUNG=0 # zurücksetzen auf Startwert
        fi

		ACTUAL_FIELD_NUMBER=$i
		case $ACTUAL_FIELD_NUMBER in

         1) # FIELD_01
            KEY_BUFFERS=""
            field_text_length=${#FIELD_01}
            z=5
            s=4
            s=$((s+field_text_length+1))
            field_input_length=15
            tmp="FIELD_0"$ACTUAL_FIELD_NUMBER
            goto_xy_input $z $s $field_input_length ${tmp}
            EXIT_MASK=$FALSCH
            #ACTUAL_FIELD_NUMBER=$((ACTUAL_FIELD_NUMBER+1))
           ;;
         2) # FIELD_02
            KEY_BUFFERS=""
            field_text_length=${#FIELD_02}
            z=6
            s=4
            s=$((s+field_text_length+1))
            field_input_length=5
            tmp="FIELD_0"$ACTUAL_FIELD_NUMBER
            goto_xy_input $z $s $field_input_length ${tmp}
            EXIT_MASK=$FALSCH
            #ACTUAL_FIELD_NUMBER=$((ACTUAL_FIELD_NUMBER+1))
           ;;
         3) # FIELD_03
            KEY_BUFFERS=""
            field_text_length=${#FIELD_03}
            z=7
            s=4
            s=$((s+field_text_length+1))
            field_input_length=5
            tmp="FIELD_0"$ACTUAL_FIELD_NUMBER
            goto_xy_input $z $s $field_input_length ${tmp}
            EXIT_MASK=$FALSCH
            #ACTUAL_FIELD_NUMBER=$((ACTUAL_FIELD_NUMBER+1))
           ;;
         4) # FIELD_04
            KEY_BUFFERS=""
            field_text_length=${#FIELD_04}
            z=8
            s=4
            s=$((s+field_text_length+1))
            field_input_length=5
            tmp="FIELD_0"$ACTUAL_FIELD_NUMBER
            goto_xy_input $z $s $field_input_length ${tmp}
            EXIT_MASK=$FALSCH
            #ACTUAL_FIELD_NUMBER=$((ACTUAL_FIELD_NUMBER+1))
           ;;
         5) # FIELD_05
            KEY_BUFFERS=""
            field_text_length=${#FIELD_05}
            z=9
            s=4
            s=$((s+field_text_length+1))
            field_input_length=5
            tmp="FIELD_0"$ACTUAL_FIELD_NUMBER
            goto_xy_input $z $s $field_input_length ${tmp}
            EXIT_MASK=$FALSCH
            #ACTUAL_FIELD_NUMBER=$((ACTUAL_FIELD_NUMBER+1))
           ;;
         6) # FIELD_06
            KEY_BUFFERS="" 
            field_text_length=${#FIELD_06}
            z=14
            s=4
            s=$((s+field_text_length+1))
            field_input_length=3
            tmp="FIELD_0"$ACTUAL_FIELD_NUMBER
            goto_xy_input $z $s $field_input_length ${tmp} 
            #"Frage_J_N"
            # EXIT_MASK=$FALSCH  # Remarken wenn es nicht die J/N abfrage ist!
            #echo $KEY_BUFFERS "+++++++++++++++++++++++++++++" $KEY_BUFFERS
            if [ "$KEY_BUFFERS" = "J" -o "$KEY_BUFFERS" = "j" ]
            then
                EXIT_MASK=$WAHR
            else
                EXIT_MASK=$FALSCH    
            fi
            
           ;;

		esac

    done
 
  done
  
  unset KEY_BUFFERS
  unset KEY_BUFFER
  
 

}
