#!/bin/bash
# 
# 10.01.2018
#
# (c) Uwe von Royen
#
#-----------------------------
# Programm für UvRNC
#-----------------------------
# Programm: versionsverwaltung
# Filename: menue.sh
# Version : 2.0.1
# Stand   : 2019.05.27
#-----------------------------

# include Dateien

. global_var.inc
. filename.inc
. library_uvr.inc
. logging.inc



menue()
{
 local func=${FUNCNAME[0]}
 #local wahl=$PS3
 local _exit=0
 local options=""
 local opt=""
 local opt_tmp=""
 
 logging 900 $func
 
 
 clear
 while [ true ]
 do 	
 printf "$MENUE_TITEL"
 printf "$CRLF"
 printf "$MENUE_TITEL_SUB"
 printf "$CRLF" 
 printf "$CRLF"
 
 options=("  Projekt"  "  Verzeichnis" "  Add" "  Ende" )
 select opt in "${options[@]}"
 do
   
   opt_tmp="${opt:2:3}"
   case $opt_tmp in
        "Pro") 
			   printf "+++ Projekt +++"
			   maske_01
			   #sleep 3
			   break
            ;;
		"Ver") 
			   printf "+++ Sourcen-Verzeichnis +++"
			   
			   sleep 6
			   break
            ;;
        "Add") 
			   printf "+++ Hinzufügen in Versionsverwaltung +++"
			   			   
			   sleep 6
			   break
            ;;
        "End") 
			   exit=1			   
			   break
            ;; 
           
         *) 
           printf "Falsche Auswahl, nur Ziffern von 1 bis 4 sind erlaubt!"
           sleep 2
           echo
           clear
           break
           ;;     
	esac
	
 done
 
 if [ $exit -eq 1 ]
 then
       break
 fi
 clear
 done
 logging 999 $func
}


menue
